﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private name As String
	Private innerTags As List
	Private attributes As Map
	Private mode As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(tagName As String) As Tag
	innerTags.Initialize
	attributes.Initialize
	name = tagName
	mode = "normal"
	Return Me
End Sub

public Sub build(indent As Int) As String
	Dim htmlText As StringBuilder
	htmlText.Initialize
	
	htmlText.Append(CRLF)
	For i = 0 To indent
		htmlText.Append("	")
	Next
	
	htmlText.Append("<"&name)
	
	For Each k As String In attributes.Keys
		Dim arrV() As String = attributes.Get(k)
		htmlText.Append(" "&k&"=""")
		
		For i = 0 To arrV.Length -1
			htmlText.Append(arrV(i))
			
			If i < arrV.Length -1 Then
				htmlText.Append(", ")
			End If
		Next	
		
		htmlText.Append("""")
	Next

	If mode = "normal" Then
		htmlText.Append(">")
	else if mode = "link" Then
		htmlText.Append(" />")
	else if mode = "meta" Then
		htmlText.Append(">")
	End If

	For i = 0 To innerTags.Size - 1
		Dim tagOrString As Object = innerTags.Get(i)
		If tagOrString Is Tag Then
			Dim tg As Tag = tagOrString
			htmlText.Append(tg.build(indent + 1))
		Else
			Dim str As String = tagOrString
			htmlText.Append(str)
		End If
	Next
	
	If mode = "normal" Then
		htmlText.Append(CRLF)
		For i = 0 To indent
			htmlText.Append("	")
		Next		
		 
		htmlText.Append("</"&name&">")
	End If
	
	Return htmlText.ToString
End Sub

public Sub GetName As String
	Return name
End Sub

public Sub SetName(tagName As String) As Tag
	name = tagName
	Return Me
End Sub

public Sub GetHTML(index As Int) As String
	Return innerTags.Get(index)
End Sub

public Sub SetHTML(innerHTMLToAdd As String) As Tag
	innerTags.Add(innerHTMLToAdd)
	Return Me
End Sub

public Sub GetListOfTags As List
	Return innerTags
End Sub

public Sub addTag(tagToAdd As Tag) As Tag
	innerTags.Add(tagToAdd)
	Return Me
End Sub

public Sub addAttribute(attrName As String,attrValue() As String) As Tag
	attributes.Put(attrName,attrValue)
	Return Me
End Sub

public Sub removeAttribute(attrName As String) As Tag
	attributes.Remove(attrName)
	Return Me
End Sub

'Accepted values
'meta 
'link
'normal
public Sub specialMode(changeMode As String) As Tag
	mode = changeMode.ToLowerCase
	Return Me
End Sub